# *Zentralbibliothek Zürich*: Metadatenabfrage und -analyse mit _KoLibri_ (Software)

[![Binder](https://mybinder.org/badge_logo.svg)](https://mybinder.org/v2/gh/zb-saml/suche-zb-katalog/main?labpath=Einfache_Suchabfrage_ZB-Katalog.ipynb)
[![made-with-python](https://img.shields.io/badge/Made%20with-Python-1f425f.svg)](https://www.python.org/)
[![PyPi license](https://badgen.net/pypi/license/pip/)](https://pypi.org/project/pip/)
[![PyPI status](https://img.shields.io/pypi/status/ansicolortags.svg)](https://pypi.python.org/pypi/ansicolortags/)
[![Github all releases](https://img.shields.io/github/downloads/Naereen/StrapDown.js/total.svg)](https://GitHub.com/Naereen/StrapDown.js/releases/)

<span style="color:blue">**Projektversion: 1.0.2 - letzte Aktualisierung: 11. Dezember 2024**</span>

5. Mai 2023 - Linda Samsinger (Data Librarian @ ZB )

Willkommen auf der Startseite der Zentralbibliothek Zürich zur Nutzung des Tools KoLibri, eine Serie von Jupyter Notebooks (*.ipynb), die eine Suchabfrage des Bibliothekskatalogs ermöglichen! Dies ist das erste Projekt in der Reihe und dient dazu, den **Bibliothekskatalog mit Suchbegriffen abzufragen und die Suchresultate in Excel, CSV oder JSON lokal abzuspeichern**. Im Kern geht es darum, eine **einfache Stichwortsuche** auszuführen und aus dem schweizweiten SLSP-Bibliothekskatalog (Netzwerkzone) von mehr als 25 Millionen Einträgen die Metadaten der Medien als Resultate zurückzubekommen. Das ermöglicht es den Benutzern, 
* schweizweite Katalogdaten als (Excel-)Grundlage für die akademische Forschungsarbeit zu beziehen
* Medien der Bibliotheken über Swisscovery-Links einfach zu bestellen und auszuleihen
* PDFs über die Inhaltsverzeichnis-Links in der Ergebnisdatei herunterzuladen
* statistische Analysen und Visualisierungen von Katalogdaten durchzuführen.

Da der SLSP-Katalog mittels einer [SRU-Schnittstelle](https://data.zb.uzh.ch/map/books/data-map-der-zentralbibliothek-zurich/page/alma-sru) (>25 Mio. Einträge) abgefragt wird, können die Ergebnisse vom [Swisscovery-Katalog](https://uzb.swisscovery.slsp.ch/discovery/search?vid=41SLSP_UZB:UZB) (>6 Mio. Einträge) abweichen, weil es sich um unterschiedliche Kataloge handelt. 

## Beispiel

![Jupyter Notebook "Einfache Suchabfrage mit Heidi"](/einfache_suchabfrage.PNG)


## Demo
![Demo: Lokale Ausführung der Jupyter Notebook Software](/demo.gif)

## Überblick
Die Jupyter Notebooks sind im Ordner "notebooks" für verschiedene Plattformen zu finden. Die Unterordner von "notebooks" sind: 

- online: "jupyterlite_notebooks" für die schnelle, online Jupyterlite-Plattform-Ausführung 
- offline: "local_installation_notebooks" für den Download und die lokale Ausführung der Jupyter Notebooks mittels der Software Jupyter Notebook auf Ihrem Computer 

### Jupyter Notebooks

Jedes der sechs Jupyter Notebooks importiert am Anfang die ganze Code-Grundlage aus dem nullten Master-Jupyter Notebook, damit die sechs restlichen Jupyter Notebooks relativ kurz und schnell ausgeführt werden können. Die ersten drei Jupyter Notebooks haben keine Wikidata-/GND-angereicherten Felder, die letzten drei Jupyter Notebooks können mit Wikidata/GND-Feldern angereichert werden. Für jedes der drei Jupyter Notebooks gibt es ein Jupyter Notebook für die einfache Suchabfrage, die fortgeschrittene Suchabfrage und eine entsprechende Datenanalyse. 

<table>
    <thead>
        <tr>
            <th>Ausgabe 🌾</th>
            <th>Suche 🔎</th>
            <th>Analyse 📈</th>
        </tr>
    </thead>
    <tbody>
        <tr>
            <td class="tg-0pky" rowspan="2">Ohne Wikidata/GND</td>
            <td class="tg-0pky">1. Einfache Suchabfrage</td>
            <td class="tg-c3ow" rowspan="2">3. Datenanalyse</td>
        </tr>
        <tr>
            <td class="tg-0pky">2. Fortgeschrittene Suchabfrage</td>
        </tr>
        <tr>
            <td class="tg-0pky" rowspan="2">Mit Wikidata/GND</td>
            <td class="tg-0pky">4. Einfache Suchabfrage inkl. Wikidata und GND</td>
            <td class="tg-0pky" rowspan="2">6. Wikidata und GND-Datenanalyse</td>
        </tr>
        <tr>
            <td class="tg-0pky">5. Fortgeschrittene Suchabfrage inkl. Wikidata und GND</td>
        </tr>
    </tbody>
</table>




## Nutzung (online)

Starten Sie Jupyter Notebooks in Ihrem Webbrowser mit **Jupyterlite** - ganz ohne komplexe Vorinstallation von Python-Paketen. Sobald das Jupyterlite-Interface geladen hat, können Sie vorhandene Jupyter Notebooks öffnen und bearbeiten. (Achtung: Funktionalitäten wie die PDF-Inhaltsverzeichnisse herunterladen, Weltkarten und Wortwolken erstellen sind nicht vorhanden)

- Jupyter Notebooks auf Jupyterlite: https://zentralbibliothek-zuerich.pages.uzh.ch/zb-suche-katalog

![Jupyter Notebooks online"](/jupyterlite-jupyternotebooks.jpg)

Nach erfolgter Anmeldung können Sie die Jupyter Notebooks auch auf **Jetbrains Datalore** nutzen.  

- Jupyter Notebooks auf Jetbrains Datalore: 

-- einfache Suche: https://datalore.jetbrains.com/notebook/2yzRTIFoi0eboaJ3ULRpoM/pzv4f9vU5XD1bOJMIEX6IR

-- fortgeschrittene Suche: https://datalore.jetbrains.com/notebook/2yzRTIFoi0eboaJ3ULRpoM/DMrM4QWIfphH3P8ljuBX0n

-- Datenanalyse: https://datalore.jetbrains.com/notebook/2yzRTIFoi0eboaJ3ULRpoM/vO5FKQkYM2UGCzi6lyqIS1

-- Suchabfrage mit GND: https://datalore.jetbrains.com/notebook/2yzRTIFoi0eboaJ3ULRpoM/yGRiOzUbmL0GAhefHqD1EB

-- Datenanalyse GND: https://datalore.jetbrains.com/notebook/2yzRTIFoi0eboaJ3ULRpoM/VyVUkJbvKU7IqPX4cEyghE

 
## Nutzung (offline)

Offline sind die Jupyter Notebooks vollumfänglicher als online. Dank dem grösseren Speicherplatz, der zur Verfügung steht, und der C-Kompatibilität lassen sich mehr Funktionalitäten ausführen als in der Online-Version.

Die Jupyter Notebooks wurden auf einem Windows-Gerät entwickelt. Deshalb sind zum Beispiel Systempfade nach dem Windows-Standard konfiguriert. 

- Python 

Die verwendete Pythonversion für das Projekt ist 3.9..

Installieren Sie Python über https://www.python.org/ und stellen Sie sicher, dass der Dateipfad zu python.exe in Ihrer Systemumgebungsvariable aufgeführt ist. 

- Git 

Um das Projekt auf Gitlab lokal auf Ihrem Computer auszuführen, laden Sie dieses Gitlab-Verzeichnis als zip-Ordner auf Ihren Computer herunter (schauen Sie unter "Downloads" nach) oder klonen Sie es auf Ihren Computer mit Git. Ein Programm, welches dabei helfen kann, ist Github Desktop (GUI) oder das Python Git-Modul (CLI). Falls Pip als Paketmanager auf dem  Computer installiert ist, kann in der Kommandzeile Git installiert werden mit: 

```
$ pip install git
``` 

Stellen Sie sicher, dass Git auf Ihrem Computer ausführbar ist: 

```
$ git
```

Mit Git kann man dieses Verzeichnis lokal herunterklonen: 

```
$ git clone https://gitlab.uzh.ch/zentralbibliothek-zuerich/zb-suche-katalog.git
``` 

- Jupyter Notebook 

In der Kommandozeile kann das Python Jupyter Notebook-Modul installiert werden (CLI): 

```
$ pip install notebook
``` 

Um ein Jupyter Notebook auszuführen: 

```
$ jupyter notebook
``` 

Alternativ kann [Anaconda](https://www.anaconda.com/download) installiert werden (GUI). Nachdem es installiert ist, öffnen Sie das Programm Jupyter Notebook und navigieren Sie im heruntergeladenen GitLab-Verzeichnis zur Jupyter Notebook-Datei (notebooks > local_installation_notebooks). Öffnen Sie die Jupyter Notebook-Datei, um es auszuführen. 

Beim ersten Mal, muss im Master-Notebook (_0_notebook_master.ipynb) der folgende auskommentierte Code einkommentiert und ausgeführt werden, um alle Python-Module zu installieren: 
### Virtuelle Umgebung einrichten
```
!pip install virtualenv
!virtualenv pymarc_env
!.\pymarc_env\Scripts\activate
```
### In virtueller Umgebung Module installieren
```
!pip install -r requirements.txt
```

## Benutzung

Zuerst müssen alle abhängigen Python-Module auf Ihrem Computer installiert werden. Kommentieren Sie dazu in der Jupyter Notebook-Datei den Code-Block "Module installieren" ein und führen Sie den Code-Block aus. Nach der Installation aller Modul-Abhängigkeiten auf Ihrem Computer können Sie das Jupyter Notebook ausführen, in dem Sie den Code-Block "Module installieren" wieder auskommentieren und alle anderen Code-Blocks im Jupyter Notebook einzeln nacheinander oder in einem Zug durchlaufen lassen. Öffnen Sie zuletzt Ihren Explorer auf Ihrem Computer, navigieren Sie zum Projekt-Verzeichnis und suchen Sie nach dem Suchergebnis, um es anzuzeigen. 

Falls die Jupyter Notebooks für einen akademischen Zweck oder zur Veröffentlichung gebraucht wurden, erstellen Sie bitte eine entsprechende Referenz für dieses Projekt. Für **Referenzangaben** finden Sie unter der Datei [CITATION](https://gitlab.uzh.ch/zentralbibliothek-zuerich/zb-suche-katalog/-/blob/09e8f634dbb0152510af052833e36386fa5f8d98/CITATION) mehr Informationen. 

## Beitrag
Sie können zu diesem Jupyter Notebook-Projekt beitragen. Dazu öffnen Sie "Issues" auf GitLab, um Fehler zu melden oder neue Funktionen vorzuschlagen. Wenn Sie **Code-Änderungen** vorschlagen möchten, erstellen Sie bitte einen Pull Request auf GitLab. 

Sie können auch basierend auf diesem Jupyter Notebook-Projekt ihr eigenes Projekt entwickeln. Kreieren Sie dazu einen Ast unter "Branches" auf GitLab. 

Nach einer Reihe an Änderungen der Dateien in diesem Verzeichnis wird eine neue **Projektversion** ausgestellt. Die Versionierung des Projekt wird im [CHANGELOG](https://gitlab.uzh.ch/zentralbibliothek-zuerich/zb-suche-katalog/-/blob/09e8f634dbb0152510af052833e36386fa5f8d98/CHANGELOG) nachgeführt.  

## Lizenz 
Dieses Jupyter Notebook-Projekt wurde unter der **MIT-Lizenz** veröffentlicht. Lesen Sie die Lizenzdatei unter [LICENSE](https://gitlab.uzh.ch/zentralbibliothek-zuerich/zb-suche-katalog/-/blob/09e8f634dbb0152510af052833e36386fa5f8d98/LICENSE) für weitere Informationen. 
